Module javafx.graphics
Package javafx.scene.layout

# Class BorderImage

java.lang.Object
javafx.scene.layout.BorderImage

public class BorderImage extends Object
Defines properties describing how to render an image as the border of some Region. A BorderImage must have an Image specified (it cannot be null). The `repeatX` and `repeatY` properties define how the image is to be repeated in each direction. The `slices` property defines how to slice up the image such that it can be stretched across the Region, while the `widths` defines the area on the Region to fill with the border image. Finally, the `outsets` define the distance outward from the edge of the border over which the border extends. The outsets of the BorderImage contribute to the outsets of the Border, which in turn contribute to the bounds of the Region.

Because the BorderImage is immutable, it can safely be used in any cache, and can safely be reused among multiple Regions.

When applied to a Region with a defined shape, a BorderImage is ignored.

Since:
  JavaFX 8.0

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BorderImage(Image image, BorderWidths widths, Insets insets, BorderWidths slices, boolean filled, BorderRepeat repeatX, BorderRepeat repeatY)`
  Creates a new BorderImage.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final Image`
  `getImage()`
  The image to be used.
  `final Insets`
  `getInsets()`
  The insets of the BorderImage define where the border should be positioned relative to the edge of the Region.
  `final BorderRepeat`
  `getRepeatX()`
  Indicates in what manner (if at all) the border image is to be repeated along the x-axis of the region.
  `final BorderRepeat`
  `getRepeatY()`
  Indicates in what manner (if at all) the border image is to be repeated along the y-axis of the region.
  `final BorderWidths`
  `getSlices()`
  Defines the slices of the image.
  `final BorderWidths`
  `getWidths()`
  The widths of the border on each side.
  `final boolean`
  `isFilled()`
  Specifies whether or not the center patch (as defined by the left, right, top, and bottom slices) should be drawn.

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### BorderImage

    public BorderImage(Image image, BorderWidths widths, Insets insets, BorderWidths slices, boolean filled, BorderRepeat repeatX, BorderRepeat repeatY)
    Creates a new BorderImage. The image must be specified or a NullPointerException will be thrown.
    Parameters:
      `image` - The image to use. This must not be null.
      `widths` - The widths of the border in each dimension. A null value results in Insets.EMPTY.
      `insets` - The insets at which to place the border relative to the region. A null value results in Insets.EMPTY.
      `slices` - The slices for the image. If null, defaults to BorderImageSlices.DEFAULT
      `filled` - A flag indicating whether the center patch should be drawn
      `repeatX` - The repeat value for the border image in the x direction. If null, defaults to STRETCH.
      `repeatY` - The repeat value for the border image in the y direction. If null, defaults to the same value as repeatX.

- ## Method Details

  - ### getImage

    public final Image getImage()
    The image to be used. This will never be null. If this image fails to load, then the entire BorderImage will be skipped at rendering time and will not contribute to any bounds or other computations.
    Returns:
      the image to be used

  - ### getRepeatX

    public final BorderRepeat getRepeatX()
    Indicates in what manner (if at all) the border image is to be repeated along the x-axis of the region. If not specified, the default value is STRETCH.
    Returns:
      the BorderRepeat that indicates if the border image is to be repeated along the x-axis of the region

  - ### getRepeatY

    public final BorderRepeat getRepeatY()
    Indicates in what manner (if at all) the border image is to be repeated along the y-axis of the region. If not specified, the default value is STRETCH.
    Returns:
      the BorderRepeat that indicates if the border image is to be repeated along the y-axis of the region

  - ### getWidths

    public final BorderWidths getWidths()
    The widths of the border on each side. These can be defined as either to be absolute widths or percentages of the size of the Region, `BorderWidths` for more details. If null, this will default to being 1 pixel wide.
    Returns:
      the BorderWidths of the border on each side

  - ### getSlices

    public final BorderWidths getSlices()
    Defines the slices of the image. JavaFX uses a 4-slice scheme where the slices each divide up an image into 9 patches. The top-left patch defines the top-left corner of the border. The top patch defines the top border and the image making up this patch is stretched horizontally (or whatever is defined for repeatX) to fill all the required space. The top-right patch goes in the top-right corner, and the right patch is stretched vertically (or whatever is defined for repeatY) to fill all the required space. And so on. The center patch is stretched (or whatever is defined for repeatX, repeatY) in each dimension. By default the center is omitted (ie: not drawn), although a BorderImageSlices value of `true` for the `filled` property will cause the center to be drawn. A default value for this property will result in BorderImageSlices.DEFAULT, which is a border-image-slice of 100%
    Returns:
      the BorderWidths that defines the slices of the image
    See Also:
      - border-image-slice

  - ### isFilled

    public final boolean isFilled()
    Specifies whether or not the center patch (as defined by the left, right, top, and bottom slices) should be drawn.
    Returns:
      true if the center patch should be drawn

  - ### getInsets

    public final Insets getInsets()
    The insets of the BorderImage define where the border should be positioned relative to the edge of the Region. This value will never be null.
    Returns:
      the insets of the BorderImage